unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FastRGB, FastBMP;

type
  TForm2 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Buf,
    Bmp: TFastBMP;
    Style: Integer;
    procedure Draw(hDC:Integer);
    procedure FormRepaint(var Msg:TWMEraseBkgnd); message WM_ERASEBKGND;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.Draw(hDC:Integer);
var
Tmp: TFastBMP;
begin
  case Style of
    0: Bmp.Draw(hDC,0,0);
    1: Bmp.Stretch(hDC,0,0,ClientWidth,ClientHeight);
    2: Bmp.TileDraw(hDC,0,0,ClientWidth,ClientHeight);
    3: begin
         Tmp:=TFastBMP.Create(ClientWidth,ClientHeight);
         Bmp.Resize(Tmp);
         Tmp.Draw(hDC,0,0);
         Tmp.Free;
       end;
    4: begin
         Tmp:=TFastBMP.Create(ClientWidth,ClientHeight);
         Bmp.SmoothResize(Tmp);
         Tmp.Draw(hDC,0,0);
         Tmp.Free;
       end;
  end;
end;

procedure TForm2.FormRepaint(var Msg:TWMEraseBkgnd);
var
rUpd,
rWin,
rBmp: Integer;
begin
  if Style=0 then
  begin
    rWin:=CreateRectRgn(0,0,ClientWidth,ClientHeight);
    rBmp:=CreateRectRgn(0,0,Bmp.Width,Bmp.Height);
    CombineRgn(rWin,rWin,rBmp,RGN_DIFF);
    Draw(Msg.DC);
    FillRgn(Msg.DC,rWin,Brush.Handle);
    DeleteObject(rWin);
    DeleteObject(rBmp);
  end else
  begin
    //Draw(Msg.DC);
    Draw(Canvas.Handle);
  end;
  Msg.Result:=1;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Bmp:=TFastBMP.CreateFromFile('fastbmp.bmp');
  Buf:=TFastBMP.CreateCopy(Bmp);
  ClientWidth:=Bmp.Width;
  ClientHeight:=Bmp.Height;
end;

end.
